'use strict';

exports.__esModule = true;
exports.parse = parse;
exports.serialize = serialize;

var _potatoEngine = require('potato-engine');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parse(lines) {
  return lines.map((line, y) => line.split('').map((symbol, x) => {
    const EntityType = _potatoEngine.entities.getEntityTypeBySymbol(symbol);
    const inst = EntityType && new EntityType([x, y], EntityType.attributesBySymbol.get(symbol));
    (0, _invariant2.default)(symbol === ' ' || inst, 'Level contained unknown symbol %s (dec %s).', symbol, symbol.charCodeAt(0));
    return inst;
  }));
}

function serialize(board) {
  return board.board.map(line => line.map(inst => {
    let symbol = ' ';
    if (inst) {
      symbol = inst.symbol;
      (0, _invariant2.default)(symbol, 'Unable to serialize level. Tried to serialize %s with attribute %s, which is not serializable.', inst.constructor.__name, inst.attribute);
    }
    return symbol;
  }).join('')).join('\n');
}